//
//  Body.cpp
//  SimpleProg
//
//  Created by kumada on 2013/08/24.
//  Copyright (c) 2013年 kumada. All rights reserved.
//

#include "Body.h"


const std::vector<const Vertex*> Body::extract_vertices(int face_index) const
{
        const Face* face = get_face(face_index);
        const Edge* edge = get_edge(face->get_edge());
        const Edge* start_edge = edge;
        
        std::vector<const Vertex*> vertices;
        while ( true ) {
                const Face* left_face = get_face(edge->get_left_face());
                const Vertex* v = nullptr;
                if ( face == left_face ) {
                        v = get_vertex(edge->get_end_vertex());
                        edge = get_edge(edge->get_end_clockwise_edge());
                } else {
                        v = get_vertex(edge->get_start_vertex());
                        edge = get_edge(edge->get_start_clockwise_edge_index());
                }
                vertices.push_back(v);
                if ( edge == start_edge ) {
                        break;
                }
        }
        return vertices;
}