//
//  Edge.h
//  SimpleProg
//
//  Created by kumada on 2013/08/20.
//  Copyright (c) 2013年 kumada. All rights reserved.
//

#ifndef SimpleProg_Edge_h
#define SimpleProg_Edge_h

class Vertex;
class Face;

class Edge
{
public:
        Edge() = default;
        ~Edge() = default;

        void set_start_vertex(int v)
        {
                start_vertex_index_ = v;
        }
        
        int get_start_vertex() const
        {
                return start_vertex_index_;
        }

        void set_end_vertex(int v)
        {
                end_vertex_index_ = v;
        }
        
        int get_end_vertex() const
        {
                return end_vertex_index_;
        }

        void set_start_clockwise_edge(int e)
        {
                start_clockwise_edge_index_ = e;
        }
        
        int get_start_clockwise_edge_index() const
        {
                return start_clockwise_edge_index_;
        }

        void set_end_clockwise_edge(int e)
        {
                end_clockwise_edge_index_ = e;
        }
        
        int get_end_clockwise_edge() const
        {
                return end_clockwise_edge_index_;
        }

        void set_right_face(int f)
        {
                right_face_index_ = f;
        }
        
        int get_right_face() const
        {
                return right_face_index_;
        }

        void set_left_face(int f)
        {
                left_face_index_ = f;
        }
        
        int get_left_face() const
        {
                return left_face_index_;
        }

private:
        int     start_vertex_index_;
        int     end_vertex_index_;
        int     start_clockwise_edge_index_;
        int     end_clockwise_edge_index_;
        int     right_face_index_;
        int     left_face_index_;
        
        Edge(const Edge&) = delete;
        Edge(Edge&&) = delete;
        Edge& operator=(const Edge&) = delete;
        Edge& operator=(Edge&&) = delete;
};

#endif
