//
//  Vertex.h
//  SimpleProg
//
//  Created by kumada on 2013/08/20.
//  Copyright (c) 2013年 kumada. All rights reserved.
//

#ifndef SimpleProg_Vertex_h
#define SimpleProg_Vertex_h

#include "Point.h"

class Vertex
{
public:
        typedef geo::DoublePoint3d Point;
        
        Vertex(double x, double y, double z)
                : point_{{x, y, z}} {}
        
        Vertex(const geo::DoublePoint3d& point)
                : point_(point) {}
        
        ~Vertex() = default;
        
        template<int N>
        inline friend const double& get(const Vertex& v);

        template<int N>
        inline friend double& get(Vertex& v);
        
        const geo::DoublePoint3d& get_point() const
        {
                return point_;
        }

        geo::DoublePoint3d& get_point()
        {
                return point_;
        }

        void set_index(int index)
        {
                index_ = index;
        }
        
        int get_index() const
        {
                return index_;
        }
private:
        Vertex(const Vertex&) = delete;
        Vertex(Vertex&&) = delete;
        Vertex& operator=(const Vertex&) = delete;
        Vertex& operator=(Vertex&&) = delete;
        
        Point   point_;
        int     index_;
};

template<int N>
const double& get(const Vertex& v) { return v.point_[N]; }

template<int N>
double& get(Vertex& v) { return v.point_[N]; }


#endif
